/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2007-2008 by TAKAGI Nobuhisa
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 */
#include <cstdlib>
#include <cerrno>
#include <string>
#include <vector>
#include <utility>
#include <algorithm>
#include <ostream>
#include <utility>
#include "toppers/macro_processor.hpp"
#include "toppers/diagnostics.hpp"
#include "toppers/gettext.hpp"
#include <boost/format.hpp>
#include <boost/utility.hpp>
#include <boost/lexical_cast.hpp>

namespace toppers
{
  namespace
  {
    typedef macro_processor::element element;
    typedef macro_processor::var_t var_t;
    typedef macro_processor::context context;

    inline std::tr1::int64_t get_i( var_t const& var, context const* p_ctx )
    {
      return macro_processor::to_integer( var, p_ctx );
    }
    inline std::string get_s( var_t const& var, context const* p_ctx )
    {
      return macro_processor::to_string( var, p_ctx );
    }

  }

  /*!
    *  \brief  θĿå
    *  \param[in]  line    ֹ
    *  \param[in]  arity   θĿ
    *  \param[in]  valid   ԤƤθĿ
    *  \param[in]  function_name Ȥ߹ߴؿ̾
    */
  bool macro_processor::check_arity( text_line const& line, std::size_t arity, std::size_t valid, char const* function_name )
  {
    bool result = false;
    if ( arity < valid )
    {
      error( line, _( "too few arguments for `%1%\'" ), function_name );
    }
    else if ( arity > valid )
    {
      error( line, _( "too many arguments for `%1%\'" ), function_name );
    }
    else
    {
      result = true;
    }
    return result;
  }

  /*!
   *  \brief  ѿפΤ<<黻
   *  \param[in,out]  ostr  ϥȥ꡼
   *  \param[in]      arg   ѿ򻲾Ȥ뤿Υڥ
   *  \return         ostr֤
   *  \note ߤμǤϡarg.second ϻѤƤʤ
   */
  std::ostream& operator<<( std::ostream& ostr, std::pair< var_t const*, context const* > const& arg )
  {
    for ( var_t::const_iterator iter( arg.first->begin() ), last( arg.first->end() ); iter != last; ++iter )
    {
      if ( !iter->s.empty() )
      {
        ostr << iter->s;
      }
      else if ( iter->i )
      {
        ostr << iter->i.get();
      }
      if ( boost::next( iter ) != last )
      {
        ostr << ",";
      }
    }
    return ostr;
  }

  /*!
   *  \brief  ꥹȤĹ
   *  \param[in]  line      ֹ
   *  \param[in]  arg_list  ޥ°ꥹ
   *  \param[in]  p_ctx     ޥƥ
   *  \retval     ޥֵ
   *  1ޥ°ȤƻꤷդꥹȤǿ֤
   *  1ޥ°դꥹȤǤʤ1֤ޤ1ޥ°̵ѿξ0֤
   */
  var_t bf_length( text_line const& line, std::vector< var_t > const& arg_list, context const* p_ctx )
  {
    element e;
    if ( macro_processor::check_arity( line, arg_list.size(), 1, "LENGTH" ) )
    {
      std::tr1::int64_t size = arg_list.front().size();
      e.i = size;
    }
    return var_t( 1, e );
  }

  /*!
   *  \brief  ʸΰȽ
   *  \param[in]  line      ֹ
   *  \param[in]  arg_list  ޥ°ꥹ
   *  \param[in]  p_ctx     ޥƥ
   *  \retval     ޥֵ
   *  1ޥ°2ޥ°ʸȤӤפϿ򡢤Ǥʤе֤
   */
  var_t bf_eq( text_line const& line, std::vector< var_t > const& arg_list, context const* p_ctx )
  {
    element e;
    if ( macro_processor::check_arity( line, arg_list.size(), 2, "EQ" ) )
    {
      e.i = get_s( arg_list[0], p_ctx ) == get_s( arg_list[1], p_ctx );
    }
    return var_t( 1, e );
  }

  /*!
   *  \brief  
   *  \param[in]  line      ֹ
   *  \param[in]  arg_list  ޥ°ꥹ
   *  \param[in]  p_ctx     ޥƥ
   *  \retval     ޥֵ
   *  1ޥ°̵ѿξ2°֤¾1°֤
   */
  var_t bf_alt( text_line const& line, std::vector< var_t > const& arg_list, context const* p_ctx )
  {
    element e;
    if ( macro_processor::check_arity( line, arg_list.size(), 2, "ALT" ) )
    {
      if ( !arg_list[0].empty() )
      {
        return arg_list[0];
      }
      else
      {
        return arg_list[1];                
      }
    }
    return var_t( 1, e );
  }

  /*!
   *  \brief  ꥹȤ
   *  \param[in]  line      ֹ
   *  \param[in]  arg_list  ޥ°ꥹ
   *  \param[in]  p_ctx     ޥƥ
   *  \retval     ޥֵ
   *  1ޥ°ȤͿդꥹȤγǤ2ޥ°źȤѿɾ
   *  ɾ̤˴Ť󤹤롣
   *
   *  \example
   *  $FOO[1] = 20$
   *  $FOO[2] = 10$
   *  $FOO[3] = 30$
   *  $SORT({ 1,2,3 }, "FOO")$
   *   { 2,1,3 }
   *  \endexample
   */
  var_t bf_sort( text_line const& line, std::vector< var_t > const& arg_list, context const* p_ctx )
  {
    var_t result;
    if ( macro_processor::check_arity( line, arg_list.size(), 2, "SORT" ) )
    {
      var_t list( arg_list[0] );
      std::string field( get_s( arg_list[1], p_ctx ) );
      std::vector< std::pair< element, std::tr1::int64_t > > temp;

      for ( var_t::const_iterator iter( list.begin() ), last( list.end() ); iter != last; ++iter )
      {
        std::tr1::int64_t order = iter->i.get();
        std::string name( ( boost::format( "%s[%d]" ) % field % order ).str() );
        std::map< std::string, var_t >::const_iterator m_iter( p_ctx->var_map.find( name ) );
        if ( m_iter == p_ctx->var_map.end() )
        {
          return var_t();
        }
        if ( !m_iter->second.empty() )
        {
          temp.push_back( std::make_pair( m_iter->second.front(), order ) );
        }
      }

      std::stable_sort( temp.begin(), temp.end() );

      for ( std::vector< std::pair< element, std::tr1::int64_t > >::const_iterator iter( temp.begin() ), last( temp.end() );
            iter != last;
            ++iter )
      {
        element e;
        e.i = iter->second;
        result.push_back( e );
      }
    }
    return result;
  }

  /*!
   *  \brief  Ķѿμ
   *  \param[in]  line      ֹ
   *  \param[in]  arg_list  ޥ°ꥹ
   *  \param[in]  p_ctx     ޥƥ
   *  \retval     ޥֵ
   *  1ޥ°ǻꤷĶѿ֤ͤ
   */
  var_t bf_environ( text_line const& line, std::vector< var_t > const& arg_list, context const* p_ctx )
  {
    element e;
    if ( macro_processor::check_arity( line, arg_list.size(), 1, "ENVIRON" ) )
    {
      std::string name = get_s( arg_list[0], p_ctx );
      char const* env = std::getenv( name.c_str() );
      if ( env == 0 )
      {
        return var_t();
      }
      e.s = env;
      errno = 0;
      char* endptr;
      if ( std::tr1::int64_t value = std::strtol( env, &endptr, 0 ) )
      {
        if ( *endptr == '\0' && errno == 0 )
        {
          e.i = value;
        }
      }
    }
    return var_t( 1, e );
  }

  /*!
   *  \brief  ͤ
   *  \param[in]  line      ֹ
   *  \param[in]  arg_list  ޥ°ꥹ
   *  \param[in]  p_ctx     ޥƥ
   *  \retval     ޥֵ
   *  1ޥ°ƥȡ2ޥ°ͤȤơͤ롣
   */
  var_t bf_value( text_line const& line, std::vector< var_t > const& arg_list, context const* p_ctx )
  {
    element e;
    if ( macro_processor::check_arity( line, arg_list.size(), 2, "VALUE" ) )
    {
      if ( !arg_list[0].empty() )
      {
        e.s = get_s( arg_list[0], p_ctx );
      }
      if ( !arg_list[1].empty() )
      {
        e.i = get_i( arg_list[1], p_ctx );
      }
    }
    return var_t( 1, e );
  }

  /*!
   *  \brief  ʸϢ
   *  \param[in]  line      ֹ
   *  \param[in]  arg_list  ޥ°ꥹ
   *  \param[in]  p_ctx     ޥƥ
   *  \retval     ޥֵ
   *  1ޥ°2ޥ°Ϣ뤷ƿʸ롣
   */
  var_t bf_concat( text_line const& line, std::vector< var_t > const& arg_list, context const* p_ctx )
  {
    element e;
    if ( macro_processor::check_arity( line, arg_list.size(), 2, "CAT" ) )
    {
      e.s = get_s( arg_list[0], p_ctx ) + get_s( arg_list[1], p_ctx );
    }
    return var_t( 1, e );
  }

  /*!
   *  \brief  ꥹȤνüǤɲ
   *  \param[in]  line      ֹ
   *  \param[in]  arg_list  ޥ°ꥹ
   *  \param[in]  p_ctx     ޥƥ
   *  \retval     ޥֵ
   *  1ޥ°2ޥ°Ϣ뤷ƿդꥹȤ롣
   */
  var_t bf_append( text_line const& line, std::vector< var_t > const& arg_list, context const* p_ctx )
  {
    var_t result;
    if ( macro_processor::check_arity( line, arg_list.size(), 2, "APPEND" ) )
    {
      result = arg_list[0];
      result.insert( result.end(), arg_list[1].begin(), arg_list[1].end() );
    }
    return result;
  }

  /*!
   *  \brief  ꥹȤλǤλ
   *  \param[in]  line      ֹ
   *  \param[in]  arg_list  ޥ°ꥹ
   *  \param[in]  p_ctx     ޥƥ
   *  \retval     ޥֵ
   *  1ޥ°ǻꤷꥹȤΡ2ޥ°ǻꤷǤ֤
   */
  var_t bf_at( text_line const& line, std::vector< var_t > const& arg_list, context const* p_ctx )
  {
    element e;
    if ( macro_processor::check_arity( line, arg_list.size(), 2, "CAT" ) )
    {
      try
      {
        e = arg_list[0].at( static_cast< std::vector< var_t >::size_type >( get_i( arg_list[1], p_ctx ) ) );
      }
      catch ( std::out_of_range& )
      {
        // ź
        // ä˲⤷ʤ  λ e ͤǤ뤳Ȥ
      }
    }
    return var_t( 1, e );
  }

  /*!
   *  \brief  ƥȤ
   *  \param[in]  line      ֹ
   *  \param[in]  arg_list  ޥ°ꥹ
   *  \param[in]  p_ctx     ޥƥ
   *  \retval     ޥֵ
   *  1ޥ°ǻꤷʸ롣
   */
  var_t bf_gettext( text_line const& line, std::vector< var_t > const& arg_list, context const* p_ctx )
  {
    element e;
    if ( macro_processor::check_arity( line, arg_list.size(), 1, "GETTEXT" ) )
    {
      std::string message = get_s( arg_list[0], p_ctx );
      e.s = gettext( message );
    }
    return var_t( 1, e );
  }

  /*!
   *  \brief  ޥ°ν񼰲
   *  \param[in]  line      ֹ
   *  \param[in]  arg_list  ޥ°ꥹ
   *  \param[in]  p_ctx     ޥƥ
   *  \retval     ޥֵ
   *  1ޥ°ǻꤷʸˤäơ2ޥ°ʹߤ񼰲롣
   *  񼰲ʸϡ%nȤʤȤprintfؿΥѡåȤǤ롣
   *  Τʻͤϡboost::format򻲾ȤΤȡ
   */
  var_t bf_format( text_line const& line, std::vector< var_t > const& arg_list, context const* p_ctx )
  {
    element e;
    std::size_t arity = arg_list.size();
    if ( arity < 1 )
    {
      error( line, _( "too few arguments for `%1%\'" ), "FORMAT" );
    }
    boost::format fmt( get_s( arg_list[0], p_ctx ) );
    for ( std::size_t i = 1; i < arity; i++ )
    {
      std::pair< var_t const*, context const* > arg( &arg_list[i], p_ctx );
      fmt % arg;
    }
    e.s = fmt.str();
    return var_t( 1, e );
  }

  /*!
   *  \brief  դꥹõ
   *  \param[in]  line      ֹ
   *  \param[in]  arg_list  ޥ°ꥹ
   *  \param[in]  p_ctx     ޥƥ
   *  \retval     ޥֵ
   *  1ޥ°ǻꤷդꥹȤ˴ޤޤ2ޥ°ǻꤷͤǤ
   *  Ƭõ롣
   *  ǤĤФǤؤΥǥå򡢤Ǥʤж֤ͤ
   */
  var_t bf_find( text_line const& line, std::vector< var_t > const& arg_list, context const* p_ctx )
  {
    element e;
    if ( macro_processor::check_arity( line, arg_list.size(), 2, "FIND" ) )
    {
      var_t list( arg_list[0] );
      std::tr1::int64_t value( get_i( arg_list[1], p_ctx ) );

      for ( var_t::const_iterator iter( list.begin() ), last( list.end() ); iter != last; ++iter )
      {
        if ( iter->i.get() == value ) // ȯ
        {
          e.i = iter - list.begin();  // iter  RandomAccessIterator
          return var_t( 1, e );
        }
      }
    }
    return var_t();
  }

  /*!
   *  \brief  ϰϻˤդꥹ
   *  \param[in]  line      ֹ
   *  \param[in]  arg_list  ޥ°ꥹ
   *  \param[in]  p_ctx     ޥƥ
   *  \retval     ޥֵ
   *  1ޥ°Ǻǽͤ2ޥ°ǺǸͤꤹ롣
   *  { ǽ, ǽ + 1, ... Ǹ }
   *  ȤʤդꥹȤ롣
   *  ʤ϶֤ͤ
   */
  var_t bf_range( text_line const& line, std::vector< var_t > const& arg_list, context const* p_ctx )
  {
    var_t result;
    if ( macro_processor::check_arity( line, arg_list.size(), 2, "RANGE" ) )
    {
      std::tr1::int64_t arg1( get_i( arg_list[0], p_ctx ) );
      std::tr1::int64_t arg2( get_i( arg_list[1], p_ctx ) );

      for ( ; arg1 <= arg2; ++arg1 )
      {
        element e;
        e.i = arg1;
        result.push_back( e );
      }
    }
    return result;
  }

  /*!
   *  \brief  ѿΥ
   *  \param[in]  line      ֹ
   *  \param[in]  arg_list  ޥ°ꥹ
   *  \param[in]  p_ctx     ޥƥ
   *  \retval     ޥֵ
   *  ޥ°ꤷ硢ʸ°ǻꤷե˥פʸɵ롣
   *  ե̾Ȥơ"stdout"ꤷɸϡ"stderr"ꤷɸ२顼˽Ϥ롣
   *  ե̾ά"stderr"ꤷΤȤƿ񤦡
   */
  var_t bf_dump( text_line const& line, std::vector< var_t > const& arg_list, context const* p_ctx )
  {
    std::size_t arity = arg_list.size();

    if ( arity > 1 )
    {
      error( line, _( "too many arguments for `%1%\'" ), "DUMP" );
    }

    std::string dump_str;

    // ѿʤ
    for ( std::map< std::string, var_t >::const_iterator iter( p_ctx->var_map.begin() ), last( p_ctx->var_map.end() );
          iter != last;
          ++iter )
    {
      dump_str += "$" + iter->first + "$ = { ";
      if ( !iter->second.empty() )
      {
        // ѿ
        for ( var_t::const_iterator iter2( iter->second.begin() ), last2( iter->second.end() );
              iter2 != last2;
              ++iter2 )
        {
          dump_str += "\"" + iter2->s + "\"(";
          if ( iter2->i ) // °...
          {
            dump_str += boost::lexical_cast< std::string >( *iter2->i );
          }
          dump_str += "), ";
        }
      }
      dump_str += " }\n";
    }

    std::string filename( "stderr" );
    if ( arity == 1 )
    {
      filename = get_s( arg_list[0], p_ctx );
    }
    if ( filename == "stdout" )
    {
      fputs( dump_str.c_str(), stdout );
    }
    else if ( filename == "stderr" )
    {
      fputs( dump_str.c_str(), stderr );
    }
    else
    {
      std::FILE* stream = std::fopen( filename.c_str(), "a" );
      if ( stream != 0 )
      {
        fputs( dump_str.c_str(), stream );
        std::fclose( stream );
      }
    }
    element e;
    return var_t( 1, e );
  }

  /*!
   *  \brief  ѿΥȥ졼
   *  \param[in]  line      ֹ
   *  \param[in]  arg_list  ޥ°ꥹ
   *  \param[in]  p_ctx     ޥƥ
   *  \retval     ޥֵ
   *  1ޥ°ǻꤷѿƤȥ졼롣
   *  2ޥ°ꤷ硢ʸ°ǻꤷե˥ȥ졼Ƥɵ롣
   *  ե̾Ȥơ"stdout"ꤷɸϡ"stderr"ꤷɸ२顼˽Ϥ롣
   *  ե̾ά"stderr"ꤷΤȤƿ񤦡
   */
  var_t bf_trace( text_line const& line, std::vector< var_t > const& arg_list, context const* p_ctx )
  {
    std::size_t arity = arg_list.size();

    if ( arity < 1 )
    {
      error( line, _( "too few arguments for `%1%\'" ), "TRACE" );
    }
    else if ( arity > 2 )
    {
      error( line, _( "too many arguments for `%1%\'" ), "TRACE" );
    }

    var_t value( arg_list[ 0 ] );

    std::string trace_str = "{ ";
    for ( var_t::const_iterator iter( value.begin() ), last( value.end() );
          iter != last;
          ++iter )
    {
      trace_str += "\"" + iter->s + "\"(";
      if ( iter->i ) // °...
      {
        trace_str += boost::lexical_cast< std::string >( *iter->i );
      }
      trace_str += "), ";
    }
    trace_str += " }\n";

    std::string filename( "stderr" );
    if ( arity == 2 )
    {
      filename = get_s( arg_list[ 1 ], p_ctx );
    }
    if ( filename == "stdout" )
    {
      fputs( trace_str.c_str(), stdout );
    }
    else if ( filename == "stderr" )
    {
      fputs( trace_str.c_str(), stderr );
    }
    else
    {
      std::FILE* stream = std::fopen( filename.c_str(), "a" );
      if ( stream != 0 )
      {
        fputs( trace_str.c_str(), stream );
        std::fclose( stream );
      }
    }

    element e;
    return var_t( 1, e );
  }

  /*!
   *  \brief  ⤷ʤȤ߹ߴؿ
   *  \param[in]  line      ֹ
   *  \param[in]  arg_list  ޥ°ꥹ
   *  \param[in]  p_ctx     ޥƥ
   *  \retval     ޥֵ
   *  Ȥ߹ߴؿϲԤʤޤޥ°ΥåԤʤ
   *  NOOPؿϾ "" ֤
   *  \note       ֤ͤʤΤϡ$NOOP()$Τ褦ʻȤ򤷤ȤǤʻȤʤ褦ˤ뤿ᡣ
   */
  var_t bf_noop( text_line const& line, std::vector< var_t > const& arg_list, context const* p_ctx )
  {
    element e;
    return var_t( 1, e );
  }

  macro_processor::func_t const macro_processor::builtin_function_table[] =
  {
    { "LENGTH", bf_length },
    { "EQ", bf_eq },
    { "ALT", bf_alt },
    { "SORT", bf_sort },
    { "ENVIRON", bf_environ },
    { "VALUE", bf_value },
    { "CONCAT", bf_concat },
    { "APPEND", bf_append },
    { "AT", bf_at },
    { "GETTEXT", bf_gettext },
    { "_", bf_gettext },  // GETTEXTΥΥ˥
    { "FORMAT", bf_format },
    { "FIND", bf_find },
    { "RANGE", bf_range },
    { "DUMP", bf_dump },
    { "TRACE", bf_trace },
    { "NOOP", bf_noop },
    { 0, 0 },
  };

}
