/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2007-2008 by TAKAGI Nobuhisa
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 */
/*!
 *  \file   toppers/itronx/init_helper.hpp
 *  \brief  ͥޤϥ⥸塼νإѡؿ
 */
#ifndef TOPPERS_ITRONX_INIT_HELPER_HPP_
#define TOPPERS_ITRONX_INIT_HELPER_HPP_

#include <string>
#include <map>
#include <iostream>
#include "toppers/global.hpp"
#include "toppers/itronx/static_api.hpp"
#include "toppers/itronx/asp/factory.hpp"

namespace toppers
{
  namespace itronx
  {

    /*!
     *  \brief      ͥޤϥ⥸塼νإѡؿ
     *  \param[in]  module_name   ⥸塼̾
     *  \param[in]  info_table    ŪAPI˴ؤơ֥
     *  \param[in]  table_count   info_table ǿ
     *  retval      true          
     *  retval      false         
     */
    template < class Factory >
      bool init_helper( std::string const& module_name, static_api::info const* info_table, std::size_t table_count )
    {
      try
      {
        std::map< std::string, static_api::info > temp_map;
        for ( std::size_t i = 0; ( i < table_count ) && ( info_table[ i ].type != 0 ); ++i )
        {
          temp_map[ info_table[ i ].api_name ] = info_table[ i ];
        }
        static std::map< std::string, static_api::info > const info_map( temp_map );
        global( module_name + "_static_api_info_map" ) = static_cast< void const* >( &info_map );	// GCCХк

        static Factory factory;
        global( module_name + "_factory" ) = static_cast< itronx::factory* >( &factory );
      }
      catch ( ... )
      {
        std::cerr << "module `" << module_name << "\' is failed to initialize" << std::endl;
        return false;
      }
      return true;
    }

  }
}

#endif  // ! TOPPERS_ITRONX_INIT_HELPER_HPP_
